window.Gleam.initSearch([{"doc":"lustre_dev_tools","title":"lustre_dev_tools","content":"&lt;h1 align=&quot;center&quot;&gt;Lustre Dev Tools&lt;/h1&gt;\n\n&lt;div align=&quot;center&quot;&gt;\n  Lustre&#39;s official CLI and development tooling.\n&lt;/div&gt;\n\n&lt;br /&gt;\n\n&lt;div align=&quot;center&quot;&gt;\n  &lt;a href=&quot;https://hex.pm/packages/lustre_dev_tools&quot;&gt;\n  &lt;img src=&quot;https://img.shields.io/hexpm/v/lustre_dev_tools&quot;\n      alt=&quot;Available on Hex&quot; /&gt;\n  &lt;/a&gt;\n&lt;/div&gt;\n\n&lt;div align=&quot;center&quot;&gt;\n  &lt;h3&gt;\n    &lt;a href=&quot;https://hexdocs.pm/lustre&quot;&gt;\n      Lustre\n    &lt;/a&gt;\n    &lt;span&gt; | &lt;/span&gt;\n    &lt;a href=&quot;#commands&quot;&gt;\n      Commands\n    &lt;/a&gt;\n    &lt;span&gt; | &lt;/span&gt;\n    &lt;a href=&quot;https://discord.gg/Fm8Pwmy&quot;&gt;\n      Discord\n    &lt;/a&gt;\n  &lt;/h3&gt;\n&lt;/div&gt;\n\n&lt;div align=&quot;center&quot;&gt;\n  &lt;sub&gt;Built with ❤︎ by\n  &lt;a href=&quot;https://twitter.com/hayleighdotdev&quot;&gt;Hayleigh Thompson&lt;/a&gt; and\n  &lt;a href=&quot;https://twitter.com/giacomo_cava&quot;&gt;Giacomo Cavalieri&lt;/a&gt;\n&lt;/div&gt;\n\n---\n\n## Features\n\n- Built-in **development server**.\n\n- Automatic detection and support for **TailwindCSS**.\n\n- **Bundle** and **minify** Lustre applications.\n\n- Distribute reusable **Web Components** for use outside of Gleam and Lustre.\n\n## Philosophy\n\nLustre&#39;s dev tools are designed to make the experience as simple as possible for\nfolks unfamiliar with frontend development or are exhausted at the state of\nJavaScript tooling. That means being opinionated about the tools we support and\nthe commands we provide.\n\nIf you find yourself needing more configuration or control over your build process,\nyou might be outgrowing what Lustre&#39;s dev tools have set out to provide! We&#39;d love\nto hear from those users too, though, so please open an issue or reach out on Discord\nif you think something is missing.\n\nFor more advanced users, we recommend using [vite](https://vitejs.dev) and the\n[vite-gleam](https://github.com/Enderchief/gleam-tools/tree/master/packages/vite-gleam)\npackage.\n\n## Installation\n\nLustre&#39;s dev tools are published on [Hex](https://hex.pm/packages/lustre_dev_tools)!\nYou can add them to your Gleam projects from the command line:\n\n```sh\ngleam add lustre_dev_tools --dev\n```\n\n&gt; **Note**: make sure you remember the `--dev` flag! This ensures the dev tools\n&gt; are never included in production builds.\n\nTo run any of the commands provided by the dev tools, you should run the\n`lustre/dev` module using Gleam&#39;s `run` command:\n\n```sh\ngleam run -m lustre/dev build app\n```\n\n## Commands\n\n- `lustre/dev add` - Commands for adding external binaries to your project. These\n  are run and managed by Lustre, and while not typically intended to be run manually,\n  they can be found inside `build/.lustre/bin`.\n\n  - `lustre/dev add esbuild` - Download a platform-appropriate version of the\n    esbuild binary. Lustre uses this to bundle applications and act as a development\n    server, and will automatically download the binary if either the `build` or\n    `start` commands are run.\n\n  - `lustre/dev add tailwind` - Download a platform-appropriate version of the\n    Tailwind binary. Lustre will automatically use this to compile your styles if\n    it detects a `tailwind.config.js` in your project but will not download it\n    automatically.\n\n- `lustre/dev build` - Commands to build different kinds of Lustre application.\n  These commands go beyond just running `gleam build` and handle features like\n  bundling, minification, and integration with other build tools.\n\n  - `lustre/dev build app` - Build and bundle an entire Lustre application. The\n    generated JavaScript module calls your app&#39;s `main` function on page load and\n    can be included in any Web page without Gleam or Lustre being present.\n\n  - `lustre/dev build component` - Build a Lustre component as a portable Web\n    Component. The generated JavaScript module can be included in any Web page\n    and used without Gleam or Lustre being present.\n\n- `lustre/dev start` - Start a development server for your Lustre project. This\n  command will compile your application and serve it on a local server. If your\n  application&#39;s `main` function returns a compatible `App`, this will generate\n  the necessary code to start it. Otherwise, your `main` function will be used\n  as the entry point.\n\n## Support\n\nLustre is mostly built by just me, [Hayleigh](https://github.com/hayleigh-dot-dev),\naround two jobs. If you&#39;d like to support my work, you can [sponsor me on GitHub](https://github.com/sponsors/hayleigh-dot-dev).\n\nContributions are also very welcome! If you&#39;ve spotted a bug, or would like to\nsuggest a feature, please open an issue or a pull request.\n","url":"index.html"},{"doc":"lustre/dev","title":"main","content":"pub fn main() -&gt; Nil\n The `main` function is used as the entry point for Lustre&#39;s dev tools. You\n shouldn&#39;t run this function in your code, but instead use `Gleam run` to run\n this module from the command line. To see what the dev tools can do, run:\n\n \n gleam run -m lustre/dev -- --help\n \n\nSynonyms:\nlustre/dev.main\nlustre/dev main","url":"lustre/dev.html#main"},{"doc":"lustre/dev","title":"lustre/dev","content":"","url":"lustre/dev.html"}]);